## ntirpc 1.3.1

=== CMakeLists.txt ===
# New TI-RPC  Cmake

# Current version as of Fedora 16.  Not tested with earlier.

cmake_minimum_required(VERSION 2.6.3)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules/")

# Add maintainer mode for (mainly) strict builds

include(${CMAKE_SOURCE_DIR}/cmake/maintainer_mode.cmake)

project(NTIRPC C)

# version numbers
set(NTIRPC_MAJOR_VERSION 1)
set(NTIRPC_MINOR_VERSION 3)
set(NTIRPC_PATCH_LEVEL 1)
set(VERSION_COMMENT
  "Full-duplex and bi-directional ONC RPC on TCP."
)
# version string used for packaging
set(NTIRPC_VERSION
  "${NTIRPC_MAJOR_VERSION}.${NTIRPC_MINOR_VERSION}.${NTIRPC_PATCH_LEVEL}")

# Install destination, if built standalone
get_property(USE_LIB64 GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS)
if (USE_LIB64)
	set(LIB_INSTALL_DIR lib64 CACHE PATH
		"Specify name of libdir inside install path")
else (USE_LIB64)
	set(LIB_INSTALL_DIR lib CACHE PATH
		"Specify name of libdir inside install path")
endif (USE_LIB64)

set(SYSTEM_LIBRARIES ${SYSTEM_LIBRARIES})

include(GetGitRevisionDescription)
get_git_head_revision(GIT_REFSPEC _GIT_HEAD_COMMIT)
git_describe(_GIT_DESCRIBE)

# Allow overriding of prefix
if (OVERRIDE_INSTALL_PREFIX)
  set(CMAKE_INSTALL_PREFIX ${OVERRIDE_INSTALL_PREFIX} CACHE PATH
    "Install prefix" FORCE)
endif(OVERRIDE_INSTALL_PREFIX)
message(STATUS "OVERRIDE_INSTALL_PREFIX = ${OVERRIDE_INSTALL_PREFIX}")

# Set default base directory
set(NTIRPC_BASE_DIR ${PROJECT_SOURCE_DIR} CACHE
  PATH "Path to base source directory of NTIRPC")

# Build configure options

option (USE_GSS "enable RPCSEC_GSS support" ON)

option(TIRPC_EPOLL "platform supports EPOLL or emulation" ON)

option(USE_RPC_RDMA "platform supports RDMA" OFF)
if (USE_RPC_RDMA)
  find_package(RDMA REQUIRED)
  include_directories(${RDMA_INCLUDE_DIR})
  set(SYSTEM_LIBRARIES ${SYSTEM_LIBRARIES} ${RDMA_LIBRARY})
endif(USE_RPC_RDMA)

# MSPAC support -lwbclient link flag
option(_MSPAC_SUPPORT "enable mspac Winbind support" OFF)

# Choose a shortcut build config

IF(BUILD_CONFIG)
  INCLUDE(
  ${CMAKE_SOURCE_DIR}/cmake/build_configurations/${BUILD_CONFIG}.cmake)
ENDIF()

# Build source locations and parameters

set(ALLOCATOR "jemalloc" CACHE STRING
  "specify the memory allocator to use: jemalloc|tcmalloc|libc")

# Find packages and libs we need for building
include(CheckIncludeFiles)
include(TestBigEndian)

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  set(LINUX ON)
endif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")

if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
  set(FREEBSD ON)
endif(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")

if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  set(WINDOWS ON)
  if(${CMAKE_CXX_COMPILER_ID} MATCHES "MSVC")
    set(MSVC ON)
  endif(${CMAKE_CXX_COMPILER_ID} MATCHES "MSVC")
endif(${CMAKE_SYSTEM_NAME} MATCHES "Windows")

check_include_files(stdbool.h HAVE_STDBOOL_H)
check_include_files(strings.h HAVE_STRINGS_H)
check_include_files(string.h HAVE_STRING_H)

TEST_BIG_ENDIAN(BIGENDIAN)
if(${BIGENDIAN})
  set(WORDS_BIGENDIAN ON)
else()
  set(WORDS_BIGENDIAN OFF)
endif(${BIGENDIAN})

find_package(Threads REQUIRED)
find_package(Krb5 REQUIRED gssapi)

if(KRB5_FOUND)
  set(HAVE_KRB5 ON)
  set(KRB5_VERSION 194)  # hand code until we do krb5-config --version magic
  set(_HAVE_GSSAPI ON)
endif(KRB5_FOUND)

if(_MSPAC_SUPPORT)
  find_package(WBclient REQUIRED)
  set(SYSTEM_LIBRARIES ${WBclient_LIBRARIES} ${SYSTEM_LIBRARIES})
endif(_MSPAC_SUPPORT)

if (FREEBSD)
   set(EXTRA_INCLUDE_DIR "/opt/ganesha/include")
else()
  # workaround bug in some include_directories when no extra includes
  set(EXTRA_INCLUDE_DIR "${NTIRPC_BASE_DIR}/ntirpc/")
endif(FREEBSD)

add_definitions(-DHAVE_CONFIG_H)

if (MSVC)
   add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif(MSVC)

include_directories(BEFORE
  "${PROJECT_BINARY_DIR}"
  "${NTIRPC_BASE_DIR}/ntirpc/"
  "${EXTRA_INCLUDE_DIR}"
)

# Find misc system libs
find_library(LIBRT rt)   # extended Pthreads functions
find_library(LIBNSL nsl) # sockets

set(SYSTEM_LIBRARIES
  ${LIBTIRPC_LIBRARIES}
  ${KRB5_LIBRARIES}
  gssapi_krb5
  ${SYSTEM_LIBRARIES}
  ${LIBRT}
  ${LIBNSL}
)

set(LIBNTIRPC_MAP "${PROJECT_BINARY_DIR}/src/libntirpc.map")
# subst files (need add_custom_command for dependency, fyi)
configure_file(
  "${NTIRPC_BASE_DIR}/src/libntirpc.map.in.cmake"
  "${PROJECT_BINARY_DIR}/libntirpc.map"
)

add_subdirectory(src)

# display configuration vars

message(STATUS)
message(STATUS "-------------------------------------------------------")
message(STATUS "TIRPC_EPOLL = ${TIRPC_EPOLL}")
message(STATUS "USE_RPC_RDMA = ${USE_RPC_RDMA}")

#force command line options to be stored in cache
set(_MSPAC_SUPPORT ${_MSPAC_SUPPORT}
  CACHE BOOL
   "compile with MSPAC extensions"
   FORCE)

set(TIRPC_EPOLL ${TIRPC_EPOLL}
  CACHE BOOL
   "platform has EPOLL or emulation"
   FORCE)

# grist files
configure_file(
  "${NTIRPC_BASE_DIR}/config-h.in.cmake"
  "${PROJECT_BINARY_DIR}/config.h"
)

configure_file(
  "${NTIRPC_BASE_DIR}/version-h.in.cmake"
  "${PROJECT_BINARY_DIR}/ntirpc/version.h"
)

configure_file(
  "${NTIRPC_BASE_DIR}/libntirpc.pc.in.cmake"
  "${PROJECT_BINARY_DIR}/libntirpc.pc"
)

########### install files ###############

install(FILES  ${PROJECT_BINARY_DIR}/libntirpc.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)
install(DIRECTORY  ${NTIRPC_BASE_DIR}/ntirpc DESTINATION include)
install(FILES  ${PROJECT_BINARY_DIR}/ntirpc/version.h DESTINATION include/ntirpc)

=== debian/changelog ===
ntirpc (1.3.1-1) unstable; urgency=low

  * Initial release (Closes: #805324).

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 17 Nov 2015 17:07:53 +1100

=== debian/control ===
Source: ntirpc
Section: net
Priority: optional
Maintainer: Dmitry Smirnov <onlyjob@debian.org>
Build-Depends: debhelper (>= 9), cmake
    ,libkrb5-dev
Standards-Version: 3.9.6
Homepage: https://github.com/linuxbox2/ntirpc
Vcs-Git: git://anonscm.debian.org/collab-maint/libntirpc.git
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/libntirpc.git

Package: libntirpc1.3
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: transport-independent RPC library
 Improved implementation of transport-independent RPC (TI-RPC).
 .
 Changes introduced in the ntirpc library include:
  * Bi-directional operation.
  * Full-duplex operation on the TCP (vc) transport.
  * Thread-safe operating modes:
    * new locking primitives and lock callouts (interface change).
    * stateless send/recv on the TCP transport (interface change).
  * Flexible server integration support.
  * Event channels.

Package: libntirpc-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libntirpc1.3 (= ${binary:Version}),
Description: transport-independent RPC library - development files
 Improved implementation of transport-independent RPC (TI-RPC).
 .
 Changes introduced in the ntirpc library include:
  * Bi-directional operation.
  * Full-duplex operation on the TCP (vc) transport.
  * Thread-safe operating modes:
    * new locking primitives and lock callouts (interface change).
    * stateless send/recv on the TCP transport (interface change).
  * Flexible server integration support.
  * Event channels.
 .
 This package provides development files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

#PKD  = $(abspath $(dir $(MAKEFILE_LIST)))
#PKG  = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))

%:
	dh $@ --parallel --buildsystem=cmake


override_dh_auto_configure:
#	cp -vf CMakeLists.txt.standalone CMakeLists.txt
	dh_auto_configure --                          \
            -DCMAKE_VERBOSE_MAKEFILE=ON                \
            -DCMAKE_BUILD_TYPE=Release                  \
            -DLIB_INSTALL_DIR:STRING=lib/$(DEB_HOST_MULTIARCH)

#override_dh_auto_install:
#	dh_auto_install --destdir=$(CURDIR)/debian/tmp

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp
#	dh_install -ppython-eblob
#	dh_install -Xlibeblob_python.so

#override_dh_makeshlibs:
#	dh_makeshlibs -V

=== debian/watch ===
version=3

 https://github.com/linuxbox2/ntirpc/releases \
  .*/archive/[Vv]?(\d[\d\.]+)\.tar\.(?:gz|bz2|xz)

 https://github.com/nfs-ganesha/ntirpc/releases \
  .*/archive/[Vv]?(\d[\d\.]+)\.tar\.(?:gz|bz2|xz)

## ntirpc 1.4.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,8 +14,8 @@
 
 # version numbers
 set(NTIRPC_MAJOR_VERSION 1)
-set(NTIRPC_MINOR_VERSION 3)
-set(NTIRPC_PATCH_LEVEL 1)
+set(NTIRPC_MINOR_VERSION 4)
+set(NTIRPC_PATCH_LEVEL 0)
 set(VERSION_COMMENT
   "Full-duplex and bi-directional ONC RPC on TCP."
 )

=== debian/changelog ===
ntirpc (1.4.1-1) unstable; urgency=medium

  [ Dmitry Smirnov ]
  * minor copyright correction

  [ Christoph Martin ]
  * Initial upstream branch.
  * update gbp.conf
  * Imported Upstream version 1.4.1

 -- Christoph Martin <martin@uni-mainz.de>  Fri, 30 Dec 2016 13:30:12 +0100

=== debian/control ===
--- 
+++ 
@@ -2,20 +2,24 @@
 Section: net
 Priority: optional
 Maintainer: Dmitry Smirnov <onlyjob@debian.org>
+Uploaders: Christoph Martin <martin@uni-mainz.de>
 Build-Depends: debhelper (>= 9), cmake
-    ,libkrb5-dev
-Standards-Version: 3.9.6
+    ,libkrb5-dev, libjemalloc-dev
+Standards-Version: 3.9.8
 Homepage: https://github.com/linuxbox2/ntirpc
-Vcs-Git: git://anonscm.debian.org/collab-maint/libntirpc.git
-Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/libntirpc.git
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/libntirpc.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libntirpc.git
 
-Package: libntirpc1.3
+Package: libntirpc1.4
+Section: libs
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Description: transport-independent RPC library
- Improved implementation of transport-independent RPC (TI-RPC).
+Description: new transport-independent RPC library
+ Port of Sun's transport-independent RPC library to Linux. The library
+ is intended as a replacement for the RPC code in the GNU C library,
+ providing among others support for RPC (and in turn, NFS) over IPv6.
  .
  Changes introduced in the ntirpc library include:
   * Bi-directional operation.
@@ -29,9 +33,12 @@
 Package: libntirpc-dev
 Section: libdevel
 Architecture: any
-Depends: ${misc:Depends}, libntirpc1.3 (= ${binary:Version}),
-Description: transport-independent RPC library - development files
- Improved implementation of transport-independent RPC (TI-RPC).
+Multi-Arch: same
+Depends: ${misc:Depends}, libntirpc1.4 (= ${binary:Version}),
+Description: new transport-independent RPC library - development files
+ Port of Sun's transport-independent RPC library to Linux. The library
+ is intended as a replacement for the RPC code in the GNU C library,
+ providing among others support for RPC (and in turn, NFS) over IPv6.
  .
  Changes introduced in the ntirpc library include:
   * Bi-directional operation.

## ntirpc 1.4.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 # version numbers
 set(NTIRPC_MAJOR_VERSION 1)
 set(NTIRPC_MINOR_VERSION 4)
-set(NTIRPC_PATCH_LEVEL 0)
+set(NTIRPC_PATCH_LEVEL 3)
 set(VERSION_COMMENT
   "Full-duplex and bi-directional ONC RPC on TCP."
 )

=== debian/changelog ===
ntirpc (1.4.3-3) unstable; urgency=medium

  * link with libatomic if necessary (closes: #859689)

 -- Christoph Martin <martin@uni-mainz.de>  Fri, 07 Apr 2017 13:54:21 +0200

ntirpc (1.4.3-2) unstable; urgency=medium

  * upload to unstable

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 13 Mar 2017 10:34:18 +0100

ntirpc (1.4.3-1) experimental; urgency=medium

  * change upstream to nfs-ganesha/ntirpc (watch, control, copyright)
  * Imported Upstream version 1.4.3
  * add symbols file

 -- Christoph Martin <martin@uni-mainz.de>  Wed, 18 Jan 2017 14:20:10 +0100

## ntirpc 1.4.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 # version numbers
 set(NTIRPC_MAJOR_VERSION 1)
 set(NTIRPC_MINOR_VERSION 4)
-set(NTIRPC_PATCH_LEVEL 3)
+set(NTIRPC_PATCH_LEVEL 4)
 set(VERSION_COMMENT
   "Full-duplex and bi-directional ONC RPC on TCP."
 )

=== src/CMakeLists.txt ===

add_definitions(
  -DPORTMAP
  -DINET6
  -D_GNU_SOURCE
)

# ok on Linux and FreeBSD w/GCC and clang compilers
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")

########### next target ###############

SET(ntirpc_common_SRCS
  auth_none.c
  auth_unix.c
  authunix_prot.c
  bindresvport.c
  bsd_epoll.c
  city.c
  clnt_bcast.c
  clnt_dg.c
  clnt_generic.c
  clnt_perror.c
  clnt_raw.c
  clnt_simple.c
  clnt_vc.c
  getnetconfig.c
  getnetpath.c
  getpeereid.c
  getrpcent.c
  getrpcport.c
  mt_misc.c
  pmap_clnt.c
  pmap_getmaps.c
  pmap_getport.c
  pmap_prot.c
  pmap_prot2.c
  pmap_rmt.c
  rbtree.c
  rbtree_x.c
  rpc_dplx.c
  rpc_prot.c
  rpc_callmsg.c
  rpc_commondata.c
  rpc_crc32.c
  rpc_ctx.c
  rpc_dplx_msg.c
  rpc_dtablesize.c
  rpc_generic.c
  rpc_soc.c
  rpcb_clnt.c
  rpcb_prot.c
  rpcb_st_xdr.c
  strlcpy.c
  svc.c
  svc_auth.c
  svc_auth_unix.c
  svc_auth_none.c
  svc_dg.c
  svc_generic.c
  svc_raw.c
  svc_rqst.c
  svc_run.c
  svc_simple.c
  svc_vc.c
  svc_xprt.c
  vc_generic.c
  xdr.c
  xdr_array.c
  xdr_float.c
  xdr_mem.c
  xdr_rec.c
  xdr_reference.c
  xdr_stdio.c
  xdr_inrec.c
  xdr_ioq.c
  svc_ioq.c
  work_pool.c
)

if(USE_DES)
  SET(ntirpc_des_SRCS
  auth_des.c
  authdes_prot.c
  )
endif(USE_DES)

if(USE_GSS)
  SET(ntirpc_gss_SRCS
    auth_gss.c authgss_hash.c
    authgss_prot.c
    svc_auth_gss.c
    )

  # fixme
  # libntirpc_la_LDFLAGS += $(GSSGLUE_LIBS)
  # libntirpc_la_CFLAGS = -DHAVE_RPCSEC_GSS $(GSSGLUE_CFLAGS)

endif(USE_GSS)

if(USE_RPC_RDMA)
  SET(ntirpc_rdma_SRCS
  clnt_rdma.c
  rpc_rdma.c
  svc_rdma.c
  xdr_rdma.c
  )
endif(USE_RPC_RDMA)

# declares the library
add_library(ntirpc SHARED
  ${ntirpc_common_SRCS}
  ${ntirpc_des_SRCS}
  ${ntirpc_gss_SRCS}
  ${ntirpc_rdma_SRCS}
  )

# add required libraries--for Ganesha build, it's ok for them to
# propagate (i.e., omit PRIVATE)
target_link_libraries(ntirpc ${SYSTEM_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})

# set library version and symbol namespace(s) from gen'd map file
set_target_properties(ntirpc PROPERTIES LINK_FLAGS
	"-Wl,--version-script=${PROJECT_BINARY_DIR}/libntirpc.map"
  VERSION ${NTIRPC_VERSION}
  SOVERSION "${NTIRPC_MAJOR_VERSION}.${NTIRPC_MINOR_VERSION}"
  )

install(TARGETS ntirpc DESTINATION ${LIB_INSTALL_DIR})

########### install files ###############

# We are still missing the install of docs and stuff

=== debian/changelog ===
ntirpc (1.4.4-1) unstable; urgency=high

  [ Christoph Martin ]
  * Imported Upstream version 1.4.4
  * fixes rpcbomb CVE-2017-8779 (closes: #861836)

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 15 May 2017 09:53:09 +0200

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,9 @@
 Maintainer: Dmitry Smirnov <onlyjob@debian.org>
 Uploaders: Christoph Martin <martin@uni-mainz.de>
 Build-Depends: debhelper (>= 9), cmake
-    ,libkrb5-dev, libjemalloc-dev
+    ,libkrb5-dev, libjemalloc-dev, libatomic-ops-dev
 Standards-Version: 3.9.8
-Homepage: https://github.com/linuxbox2/ntirpc
+Homepage: https://github.com/nfs-ganesha/ntirpc
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/libntirpc.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libntirpc.git

## ntirpc 1.6.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,14 +14,21 @@
 
 # version numbers
 set(NTIRPC_MAJOR_VERSION 1)
-set(NTIRPC_MINOR_VERSION 4)
-set(NTIRPC_PATCH_LEVEL 4)
+set(NTIRPC_MINOR_VERSION 6)
+set(NTIRPC_PATCH_LEVEL 1)
 set(VERSION_COMMENT
   "Full-duplex and bi-directional ONC RPC on TCP."
 )
 # version string used for packaging
 set(NTIRPC_VERSION
   "${NTIRPC_MAJOR_VERSION}.${NTIRPC_MINOR_VERSION}.${NTIRPC_PATCH_LEVEL}")
+# Up scope for embedding in ganesha
+set(NTIRPC_VERSION_EMBED "${NTIRPC_VERSION}" PARENT_SCOPE)
+set(NTIRPC_ABI_EMBED "${NTIRPC_MAJOR_VERSION}.${NTIRPC_MINOR_VERSION}" PARENT_SCOPE)
+
+set( PACKNAME "${NTIRPC_VERSION}" )
+
+set(CMAKE_POSITION_INDEPENDENT_CODE ON)
 
 # Install destination, if built standalone
 get_property(USE_LIB64 GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS)
@@ -53,8 +60,15 @@
 # Build configure options
 
 option (USE_GSS "enable RPCSEC_GSS support" ON)
-
-option(TIRPC_EPOLL "platform supports EPOLL or emulation" ON)
+if (USE_GSS)
+  find_package(Krb5 REQUIRED gssapi)
+  if(KRB5_FOUND)
+    set(HAVE_KRB5 ON)
+    set(_HAVE_GSSAPI ON)
+  else(KRB5_FOUND)
+    set(USE_GSS OFF)
+  endif(KRB5_FOUND)
+endif (USE_GSS)
 
 option(USE_RPC_RDMA "platform supports RDMA" OFF)
 if (USE_RPC_RDMA)
@@ -109,13 +123,9 @@
 endif(${BIGENDIAN})
 
 find_package(Threads REQUIRED)
-find_package(Krb5 REQUIRED gssapi)
-
-if(KRB5_FOUND)
-  set(HAVE_KRB5 ON)
-  set(KRB5_VERSION 194)  # hand code until we do krb5-config --version magic
-  set(_HAVE_GSSAPI ON)
-endif(KRB5_FOUND)
+find_package(EPOLL REQUIRED)
+set(TIRPC_EPOLL ${EPOLL_FOUND})
+find_package(Sanitizers)
 
 if(_MSPAC_SUPPORT)
   find_package(WBclient REQUIRED)
@@ -143,15 +153,14 @@
 
 # Find misc system libs
 find_library(LIBRT rt)   # extended Pthreads functions
-find_library(LIBNSL nsl) # sockets
+find_package(NSL) # sockets
 
 set(SYSTEM_LIBRARIES
   ${LIBTIRPC_LIBRARIES}
   ${KRB5_LIBRARIES}
-  gssapi_krb5
   ${SYSTEM_LIBRARIES}
   ${LIBRT}
-  ${LIBNSL}
+  ${NSL_LIBRARY}
 )
 
 set(LIBNTIRPC_MAP "${PROJECT_BINARY_DIR}/src/libntirpc.map")
@@ -169,6 +178,7 @@
 message(STATUS "-------------------------------------------------------")
 message(STATUS "TIRPC_EPOLL = ${TIRPC_EPOLL}")
 message(STATUS "USE_RPC_RDMA = ${USE_RPC_RDMA}")
+message(STATUS "USE_GSS = ${USE_GSS}")
 
 #force command line options to be stored in cache
 set(_MSPAC_SUPPORT ${_MSPAC_SUPPORT}
@@ -195,7 +205,26 @@
 configure_file(
   "${NTIRPC_BASE_DIR}/libntirpc.pc.in.cmake"
   "${PROJECT_BINARY_DIR}/libntirpc.pc"
-)
+  @ONLY
+)
+
+configure_file(
+  "${NTIRPC_BASE_DIR}/libntirpc.spec-in.cmake"
+  "${PROJECT_SOURCE_DIR}/libntirpc.spec"
+)
+
+# Define CPACK component (to deal with sub packages)
+set(CPACK_COMPONENTS_ALL daemon fsal headers )
+set(CPACK_COMPONENT_DAEMON_DISPLAY_NAME "libntirpc")
+
+# Include custom config and cpack module
+include(${CMAKE_SOURCE_DIR}/cmake/cpack_config.cmake)
+include(CPack)
+
+set( PKG_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}.tar.gz")
+if (NOT TARGET dist)
+	add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
+endif (NOT TARGET dist)
 
 ########### install files ###############

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -28,26 +28,19 @@
   getnetpath.c
   getpeereid.c
   getrpcent.c
-  getrpcport.c
   mt_misc.c
-  pmap_clnt.c
-  pmap_getmaps.c
-  pmap_getport.c
   pmap_prot.c
   pmap_prot2.c
   pmap_rmt.c
   rbtree.c
   rbtree_x.c
-  rpc_dplx.c
   rpc_prot.c
   rpc_callmsg.c
   rpc_commondata.c
   rpc_crc32.c
-  rpc_ctx.c
   rpc_dplx_msg.c
   rpc_dtablesize.c
   rpc_generic.c
-  rpc_soc.c
   rpcb_clnt.c
   rpcb_prot.c
   rpcb_st_xdr.c
@@ -60,30 +53,18 @@
   svc_generic.c
   svc_raw.c
   svc_rqst.c
-  svc_run.c
   svc_simple.c
   svc_vc.c
   svc_xprt.c
-  vc_generic.c
   xdr.c
   xdr_array.c
   xdr_float.c
   xdr_mem.c
-  xdr_rec.c
   xdr_reference.c
-  xdr_stdio.c
-  xdr_inrec.c
   xdr_ioq.c
   svc_ioq.c
   work_pool.c
 )
-
-if(USE_DES)
-  SET(ntirpc_des_SRCS
-  auth_des.c
-  authdes_prot.c
-  )
-endif(USE_DES)
 
 if(USE_GSS)
   SET(ntirpc_gss_SRCS
@@ -110,7 +91,6 @@
 # declares the library
 add_library(ntirpc SHARED
   ${ntirpc_common_SRCS}
-  ${ntirpc_des_SRCS}
   ${ntirpc_gss_SRCS}
   ${ntirpc_rdma_SRCS}
   )

=== tests/Makefile ===
GANESHA_BUILD=/opt/GANESHA/build-nfs
CFLAGS=-g -Wall -Werror -I../ntirpc
LDFLAGS=-L$(GANESHA_BUILD)/libntirpc/src

all: nfs4_testmsk nfs4_server

nfs4_testmsk: nfs4_testmsk.c nfs4_xdr.o
	gcc $(CFLAGS) $(LDFLAGS) nfs4_xdr.o nfs4_testmsk.c  -o nfs4_testmsk -lntirpc -lmooshika -lrt -lpthread -lgssapi_krb5

nfs4_server: nfs4_server.c nfs4_xdr.o
	gcc $(CFLAGS) $(LDFLAGS) nfs4_xdr.o nfs4_server.c  -o nfs4_server -lntirpc -lmooshika -lrt -lpthread -lgssapi_krb5

#ignore CFLAGS for that one...
nfs4_xdr.o: nfs4_xdr.c
	gcc -g -I../tirpc -c nfs4_xdr.c

clean:
	rm -f *.o nfs4_{testmsk,server}

=== debian/changelog ===
ntirpc (1.6.1-1) unstable; urgency=medium

  * New upstream version 1.6.1

 -- Christoph Martin <martin@uni-mainz.de>  Tue, 20 Feb 2018 10:32:52 +0100

ntirpc (1.5.3-1) unstable; urgency=medium

  [ Christoph Martin ]
  * New upstream version 1.5.3

 -- Christoph Martin <martin@uni-mainz.de>  Fri, 25 Aug 2017 15:02:23 +0200

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/libntirpc.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libntirpc.git
 
-Package: libntirpc1.4
+Package: libntirpc1.6
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -34,7 +34,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libntirpc1.4 (= ${binary:Version}),
+Depends: ${misc:Depends}, libntirpc1.6 (= ${binary:Version}),
 Description: new transport-independent RPC library - development files
  Port of Sun's transport-independent RPC library to Linux. The library
  is intended as a replacement for the RPC code in the GNU C library,

=== debian/rules ===
--- 
+++ 
@@ -18,13 +18,15 @@
 	dh_auto_configure --                          \
             -DCMAKE_VERBOSE_MAKEFILE=ON                \
             -DCMAKE_BUILD_TYPE=Release                  \
-            -DLIB_INSTALL_DIR:STRING=lib/$(DEB_HOST_MULTIARCH)
+            -DLIB_INSTALL_DIR:STRING=lib/$(DEB_HOST_MULTIARCH) \
+	    -DTIRPC_EPOLL=1 \
+	    -DUSE_GSS=ON
 
 #override_dh_auto_install:
 #	dh_auto_install --destdir=$(CURDIR)/debian/tmp
 
-override_dh_auto_install:
-	dh_auto_install --destdir=debian/tmp
+#override_dh_auto_install:
+#	dh_auto_install --destdir=debian/tmp
 #	dh_install -ppython-eblob
 #	dh_install -Xlibeblob_python.so

=== debian/watch ===
version=3

 https://github.com/nfs-ganesha/ntirpc/releases \
  .*/archive/[Vv]?(\d[\d\.]+)\.tar\.(?:gz|bz2|xz)

## ntirpc 1.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,8 +14,8 @@
 
 # version numbers
 set(NTIRPC_MAJOR_VERSION 1)
-set(NTIRPC_MINOR_VERSION 6)
-set(NTIRPC_PATCH_LEVEL 1)
+set(NTIRPC_MINOR_VERSION 7)
+set(NTIRPC_PATCH_LEVEL 0)
 set(VERSION_COMMENT
   "Full-duplex and bi-directional ONC RPC on TCP."
 )
@@ -41,6 +41,7 @@
 endif (USE_LIB64)
 
 set(SYSTEM_LIBRARIES ${SYSTEM_LIBRARIES})
+set(BINARY_LIBRARIES ${BINARY_LIBRARIES})
 
 include(GetGitRevisionDescription)
 get_git_head_revision(GIT_REFSPEC _GIT_HEAD_COMMIT)
@@ -80,6 +81,34 @@
 # MSPAC support -lwbclient link flag
 option(_MSPAC_SUPPORT "enable mspac Winbind support" OFF)
 
+option(USE_PROFILE "Build with gperf profiling" OFF)
+if (USE_PROFILE)
+  find_package(Gperftools)
+  if(GPERFTOOLS_FOUND)
+    set(BINARY_LIBRARIES ${BINARY_LIBRARIES} ${GPERFTOOLS_LIBRARIES})
+  else(GPERFTOOLS_FOUND)
+    message(WARNING "Couldn't find gperftools. Disabling USE_PROFILE")
+    set(USE_PROFILE OFF)
+  endif(GPERFTOOLS_FOUND)
+endif(USE_PROFILE)
+
+option(USE_LTTNG "Enable LTTng tracing" OFF)
+if(USE_LTTNG)
+  # Set LTTNG_PATH_HINT on the command line
+  # if your LTTng is not in a standard place
+  find_package(LTTng REQUIRED)
+  if(LTTNG_FOUND)
+    include_directories(${LTTNG_INCLUDE_DIR})
+    set(USE_LTTNG_NTIRPC ON)
+    set(BINARY_LIBRARIES ${BINARY_LIBRARIES} ntirpc_lttng)
+  else(LTTNG_FOUND)
+    message(WARNING "LTTng libraries not found. Disabling USE_LTTNG_NTIRPC")
+    set(USE_LTTNG_NTIRPC OFF)
+  endif(LTTNG_FOUND)
+else(USE_LTTNG)
+  set(USE_LTTNG_NTIRPC OFF)
+endif(USE_LTTNG)
+
 # Choose a shortcut build config
 
 IF(BUILD_CONFIG)
@@ -153,15 +182,21 @@
 
 # Find misc system libs
 find_library(LIBRT rt)   # extended Pthreads functions
-find_package(NSL) # sockets
 
 set(SYSTEM_LIBRARIES
   ${LIBTIRPC_LIBRARIES}
   ${KRB5_LIBRARIES}
   ${SYSTEM_LIBRARIES}
   ${LIBRT}
-  ${NSL_LIBRARY}
-)
+)
+
+if (NOT FREEBSD)
+  find_package(NSL) # sockets
+  set(SYSTEM_LIBRARIES
+    ${SYSTEM_LIBRARIES}
+    ${NSL_LIBRARY}
+  )
+endif (NOT FREEBSD)
 
 set(LIBNTIRPC_MAP "${PROJECT_BINARY_DIR}/src/libntirpc.map")
 # subst files (need add_custom_command for dependency, fyi)
@@ -171,6 +206,7 @@
 )
 
 add_subdirectory(src)
+add_subdirectory(tests)
 
 # display configuration vars
 
@@ -179,6 +215,8 @@
 message(STATUS "TIRPC_EPOLL = ${TIRPC_EPOLL}")
 message(STATUS "USE_RPC_RDMA = ${USE_RPC_RDMA}")
 message(STATUS "USE_GSS = ${USE_GSS}")
+message(STATUS "USE_PROFILE = ${USE_PROFILE}")
+message(STATUS "USE_LTTNG_NTIRPC = ${USE_LTTNG_NTIRPC}")
 
 #force command line options to be stored in cache
 set(_MSPAC_SUPPORT ${_MSPAC_SUPPORT}
@@ -213,6 +251,7 @@
   "${PROJECT_SOURCE_DIR}/libntirpc.spec"
 )
 
+if (NOT TARGET dist)
 # Define CPACK component (to deal with sub packages)
 set(CPACK_COMPONENTS_ALL daemon fsal headers )
 set(CPACK_COMPONENT_DAEMON_DISPLAY_NAME "libntirpc")
@@ -222,7 +261,6 @@
 include(CPack)
 
 set( PKG_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}.tar.gz")
-if (NOT TARGET dist)
 	add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
 endif (NOT TARGET dist)

=== debian/changelog ===
ntirpc (1.7.0-1) unstable; urgency=medium

  * Move Vcs-* to Salsa
  * New upstream version 1.7.0
  * Remove unneeded build-depends on libatomic-ops-dev (closes: #883589)

 -- Christoph Martin <martin@uni-mainz.de>  Tue, 18 Sep 2018 16:21:10 +0200

## ntirpc 1.7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 # version numbers
 set(NTIRPC_MAJOR_VERSION 1)
 set(NTIRPC_MINOR_VERSION 7)
-set(NTIRPC_PATCH_LEVEL 0)
+set(NTIRPC_PATCH_LEVEL 1)
 set(VERSION_COMMENT
   "Full-duplex and bi-directional ONC RPC on TCP."
 )

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -57,7 +57,6 @@
   svc_vc.c
   svc_xprt.c
   xdr.c
-  xdr_array.c
   xdr_float.c
   xdr_mem.c
   xdr_reference.c
@@ -88,11 +87,16 @@
   )
 endif(USE_RPC_RDMA)
 
+if(USE_LTTNG_NTIRPC)
+  add_subdirectory(lttng)
+endif(USE_LTTNG_NTIRPC)
+
 # declares the library
 add_library(ntirpc SHARED
   ${ntirpc_common_SRCS}
   ${ntirpc_gss_SRCS}
   ${ntirpc_rdma_SRCS}
+  ${ntirpc_lttng_SRCS}
   )
 
 # add required libraries--for Ganesha build, it's ok for them to

=== src/lttng/CMakeLists.txt ===
include_directories(
  ${LTTNG_INCLUDE_DIR}
)

set(ntirpc_tracepoints_LIB_SRCS
  rpcping.c
  xprt.c
)

add_library(ntirpc_tracepoints SHARED ${ntirpc_tracepoints_LIB_SRCS})
#add_sanitizers(ntirpc_tracepoints)

target_link_libraries(ntirpc_tracepoints
  ${LTTNG_LIBRARIES}
)

set_target_properties(ntirpc_tracepoints PROPERTIES
  VERSION ${NTIRPC_VERSION}
  SOVERSION "${NTIRPC_MAJOR_VERSION}.${NTIRPC_MINOR_VERSION}"
  )

install(TARGETS ntirpc_tracepoints COMPONENT tracing DESTINATION ${LIB_INSTALL_DIR} )

set(ntirpc_lttng_LIB_SRCS
  main.c
)

add_library(ntirpc_lttng STATIC ${ntirpc_lttng_LIB_SRCS})
#add_sanitizers(ntirpc_lttng)

target_link_libraries(ntirpc_lttng
  ${LTTNG_LIBRARIES}
)

install(TARGETS ntirpc_lttng COMPONENT tracing DESTINATION ${LIB_INSTALL_DIR} )

=== debian/changelog ===
ntirpc (1.7.1-1) unstable; urgency=medium

  * New upstream version 1.7.1

 -- Christoph Martin <martin@uni-mainz.de>  Wed, 24 Oct 2018 15:41:08 +0200

=== debian/control ===
--- 
+++ 
@@ -4,13 +4,13 @@
 Maintainer: Dmitry Smirnov <onlyjob@debian.org>
 Uploaders: Christoph Martin <martin@uni-mainz.de>
 Build-Depends: debhelper (>= 9), cmake
-    ,libkrb5-dev, libjemalloc-dev, libatomic-ops-dev
+    ,libkrb5-dev, libjemalloc-dev
 Standards-Version: 3.9.8
 Homepage: https://github.com/nfs-ganesha/ntirpc
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/libntirpc.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libntirpc.git
+Vcs-Git: https://salsa.debian.org/debian/libntirpc.git
+Vcs-Browser: https://salsa.debian.org/debian/libntirpc
 
-Package: libntirpc1.6
+Package: libntirpc1.7
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -34,7 +34,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libntirpc1.6 (= ${binary:Version}),
+Depends: ${misc:Depends}, libntirpc1.7 (= ${binary:Version}),
 Description: new transport-independent RPC library - development files
  Port of Sun's transport-independent RPC library to Linux. The library
  is intended as a replacement for the RPC code in the GNU C library,

## ntirpc 1.7.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 # version numbers
 set(NTIRPC_MAJOR_VERSION 1)
 set(NTIRPC_MINOR_VERSION 7)
-set(NTIRPC_PATCH_LEVEL 1)
+set(NTIRPC_PATCH_LEVEL 4)
 set(VERSION_COMMENT
   "Full-duplex and bi-directional ONC RPC on TCP."
 )

=== debian/changelog ===
ntirpc (1.7.4-2~bpo10+1) buster-backports; urgency=medium

  * Rebuild for stretch-backports.
  * Has important bug fixes from upstream compared to 1.7.1

 -- Christoph Martin <martin@uni-mainz.de>  Thu, 20 Feb 2020 18:28:28 +0100

ntirpc (1.7.4-2) unstable; urgency=medium

  * bum standards version to 4.3.0 (no changes)

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 05 Aug 2019 10:49:15 +0200

ntirpc (1.7.4-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Change Format URL to correct one

  [ Christoph Martin ]
  * New upstream version 1.7.4

 -- Christoph Martin <martin@uni-mainz.de>  Thu, 06 Jun 2019 10:40:01 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Christoph Martin <martin@uni-mainz.de>
 Build-Depends: debhelper (>= 9), cmake
     ,libkrb5-dev, libjemalloc-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.3.0
 Homepage: https://github.com/nfs-ganesha/ntirpc
 Vcs-Git: https://salsa.debian.org/debian/libntirpc.git
 Vcs-Browser: https://salsa.debian.org/debian/libntirpc

## ntirpc 3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,18 +13,24 @@
 project(NTIRPC C)
 
 # version numbers
-set(NTIRPC_MAJOR_VERSION 1)
-set(NTIRPC_MINOR_VERSION 7)
-set(NTIRPC_PATCH_LEVEL 4)
+set(NTIRPC_MAJOR_VERSION 3)
+# This is .0 for a release, .N for a stable branch, blank for development
+set(NTIRPC_MINOR_VERSION .0)
+# -something for dev releases
+set(NTIRPC_VERSION_EXTRA )
 set(VERSION_COMMENT
   "Full-duplex and bi-directional ONC RPC on TCP."
 )
 # version string used for packaging
 set(NTIRPC_VERSION
-  "${NTIRPC_MAJOR_VERSION}.${NTIRPC_MINOR_VERSION}.${NTIRPC_PATCH_LEVEL}")
+  "${NTIRPC_MAJOR_VERSION}${NTIRPC_MINOR_VERSION}${NTIRPC_VERSION_EXTRA}")
+set(NTIRPC_VERSION_BASE
+  "${NTIRPC_MAJOR_VERSION}${NTIRPC_MINOR_VERSION}")
 # Up scope for embedding in ganesha
 set(NTIRPC_VERSION_EMBED "${NTIRPC_VERSION}" PARENT_SCOPE)
-set(NTIRPC_ABI_EMBED "${NTIRPC_MAJOR_VERSION}.${NTIRPC_MINOR_VERSION}" PARENT_SCOPE)
+set(NTIRPC_VERSION_BASE_EMBED "${NTIRPC_VERSION_BASE}" PARENT_SCOPE)
+set(NTIRPC_VERSION_EXTRA_EMBED "${NTIRPC_VERSION_EXTRA}" PARENT_SCOPE)
+set(NTIRPC_ABI_EMBED "${NTIRPC_MAJOR_VERSION}${NTIRPC_MINOR_VERSION}" PARENT_SCOPE)
 
 set( PACKNAME "${NTIRPC_VERSION}" )
 
@@ -180,6 +186,8 @@
   "${EXTRA_INCLUDE_DIR}"
 )
 
+find_library(LIBURCU urcu-bp)
+
 # Find misc system libs
 find_library(LIBRT rt)   # extended Pthreads functions
 
@@ -188,6 +196,7 @@
   ${KRB5_LIBRARIES}
   ${SYSTEM_LIBRARIES}
   ${LIBRT}
+  ${LIBURCU}
 )
 
 if (NOT FREEBSD)

=== debian/changelog ===
ntirpc (3.0-0ubuntu2) focal; urgency=medium

  * d/libntirpc3.0.symbols: Drop LTTNG related symbols accidentally
    included in last upload.
  * d/rules: Enable basic rpcping tests during package build.

 -- James Page <james.page@ubuntu.com>  Mon, 16 Dec 2019 11:17:18 +0000

ntirpc (3.0-0ubuntu1) focal; urgency=medium

  * New upstream release:
    - d/control: Bump version from 1.7->3.0.
    - d/libntirpc3.0.symbols: Update for new version.
    - d/libntirpc{1.7->3.0}.*: Rename files inline with version bump.

 -- James Page <james.page@ubuntu.com>  Tue, 10 Dec 2019 09:41:56 +0000

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,17 @@
 Source: ntirpc
 Section: net
 Priority: optional
-Maintainer: Dmitry Smirnov <onlyjob@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Dmitry Smirnov <onlyjob@debian.org>
 Uploaders: Christoph Martin <martin@uni-mainz.de>
 Build-Depends: debhelper (>= 9), cmake
-    ,libkrb5-dev, libjemalloc-dev
+    ,libkrb5-dev, libjemalloc-dev, liburcu-dev
 Standards-Version: 4.3.0
 Homepage: https://github.com/nfs-ganesha/ntirpc
 Vcs-Git: https://salsa.debian.org/debian/libntirpc.git
 Vcs-Browser: https://salsa.debian.org/debian/libntirpc
 
-Package: libntirpc1.7
+Package: libntirpc3.0
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -34,7 +35,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libntirpc1.7 (= ${binary:Version}),
+Depends: ${misc:Depends}, libntirpc3.0 (= ${binary:Version}),
 Description: new transport-independent RPC library - development files
  Port of Sun's transport-independent RPC library to Linux. The library
  is intended as a replacement for the RPC code in the GNU C library,

=== debian/rules ===
--- 
+++ 
@@ -22,6 +22,13 @@
 	    -DTIRPC_EPOLL=1 \
 	    -DUSE_GSS=ON
 
+override_dh_auto_test:
+	set -ex; \
+	cd obj-$(DEB_BUILD_GNU_TYPE); \
+	for i in raw rdma tcp udp; do \
+		./tests/rpcping $$i localhost --count=1000 --threads=4 --workers=2; \
+	done
+
 #override_dh_auto_install:
 #	dh_auto_install --destdir=$(CURDIR)/debian/tmp

=== debian/watch ===
version=3

 https://github.com/nfs-ganesha/ntirpc/releases \
  .*/archive/[Vv]?(\d[\d\.]+)\.tar\.(?:gz|bz2|xz)

 https://github.com/nfs-ganesha/ntirpc/releases?after=v1.6.1 \
  .*/archive/[Vv]?(\d[\d\.]+)\.tar\.(?:gz|bz2|xz)

## ntirpc 3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 # version numbers
 set(NTIRPC_MAJOR_VERSION 3)
 # This is .0 for a release, .N for a stable branch, blank for development
-set(NTIRPC_MINOR_VERSION .0)
+set(NTIRPC_MINOR_VERSION .2)
 # -something for dev releases
 set(NTIRPC_VERSION_EXTRA )
 set(VERSION_COMMENT
@@ -261,8 +261,6 @@
 )
 
 if (NOT TARGET dist)
-# Define CPACK component (to deal with sub packages)
-set(CPACK_COMPONENTS_ALL daemon fsal headers )
 set(CPACK_COMPONENT_DAEMON_DISPLAY_NAME "libntirpc")
 
 # Include custom config and cpack module
@@ -273,6 +271,20 @@
 	add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
 endif (NOT TARGET dist)
 
+if (NOT TARGET rpm)
+add_custom_target( rpm DEPENDS dist)
+add_custom_command(TARGET rpm
+                  COMMAND sh -c "rpmbuild -ta ${PKG_NAME}"
+		  VERBATIM
+		  DEPENDS dist)
+
+set(RPMDEST "--define '_srcrpmdir ${CMAKE_CURRENT_BINARY_DIR}'")
+add_custom_target( srpm DEPENDS dist)
+add_custom_command(TARGET srpm
+                  COMMAND sh -c "rpmbuild ${RPMDEST} -ts ${PKG_NAME}"
+		  VERBATIM
+		  DEPENDS dist)
+endif (NOT TARGET rpm)
 ########### install files ###############
 
 install(FILES  ${PROJECT_BINARY_DIR}/libntirpc.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)

=== debian/changelog ===
ntirpc (3.2-2~bpo10+1) buster-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Christoph Martin <martin@uni-mainz.de>  Wed, 05 Aug 2020 16:08:56 +0200

ntirpc (3.2-2) unstable; urgency=medium

  * source only upload to enable migration to testing

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 16 Mar 2020 10:05:50 +0100

ntirpc (3.2-1) unstable; urgency=medium

  * New upstream version 3.2

 -- Christoph Martin <martin@uni-mainz.de>  Wed, 26 Feb 2020 09:27:16 +0100

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,16 @@
 Source: ntirpc
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Dmitry Smirnov <onlyjob@debian.org>
+Maintainer: Dmitry Smirnov <onlyjob@debian.org>
 Uploaders: Christoph Martin <martin@uni-mainz.de>
 Build-Depends: debhelper (>= 9), cmake
-    ,libkrb5-dev, libjemalloc-dev, liburcu-dev
+    ,libkrb5-dev, liburcu-dev
 Standards-Version: 4.3.0
 Homepage: https://github.com/nfs-ganesha/ntirpc
 Vcs-Git: https://salsa.debian.org/debian/libntirpc.git
 Vcs-Browser: https://salsa.debian.org/debian/libntirpc
 
-Package: libntirpc3.0
+Package: libntirpc3.2
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -35,7 +34,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libntirpc3.0 (= ${binary:Version}),
+Depends: ${misc:Depends}, libntirpc3.2 (= ${binary:Version}),
 Description: new transport-independent RPC library - development files
  Port of Sun's transport-independent RPC library to Linux. The library
  is intended as a replacement for the RPC code in the GNU C library,

## ntirpc 3.3

=== debian/changelog ===
ntirpc (3.3-2) unstable; urgency=medium

  * fix libntipc3.3 symbols file (closes: #971992)
  * add Build-Depends-Package field to symbols file

 -- Christoph Martin <martin@uni-mainz.de>  Sun, 11 Oct 2020 15:06:07 +0200

ntirpc (3.3-1) unstable; urgency=medium

  * New upstream version 3.3
  * d/rules: Enable basic rpcping tests during package build (from Ubuntu)

 -- Christoph Martin <martin@uni-mainz.de>  Thu, 27 Aug 2020 16:05:17 +0200

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,16 @@
 Priority: optional
 Maintainer: Dmitry Smirnov <onlyjob@debian.org>
 Uploaders: Christoph Martin <martin@uni-mainz.de>
-Build-Depends: debhelper (>= 9), cmake
-    ,libkrb5-dev, liburcu-dev
+Build-Depends: debhelper (>= 9),
+  cmake,
+  libkrb5-dev,
+  liburcu-dev,
 Standards-Version: 4.3.0
 Homepage: https://github.com/nfs-ganesha/ntirpc
 Vcs-Git: https://salsa.debian.org/debian/libntirpc.git
 Vcs-Browser: https://salsa.debian.org/debian/libntirpc
 
-Package: libntirpc3.2
+Package: libntirpc3.3
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -34,7 +36,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libntirpc3.2 (= ${binary:Version}),
+Depends: ${misc:Depends}, libntirpc3.3 (= ${binary:Version}),
 Description: new transport-independent RPC library - development files
  Port of Sun's transport-independent RPC library to Linux. The library
  is intended as a replacement for the RPC code in the GNU C library,

## ntirpc 3.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 # version numbers
 set(NTIRPC_MAJOR_VERSION 3)
 # This is .0 for a release, .N for a stable branch, blank for development
-set(NTIRPC_MINOR_VERSION .2)
+set(NTIRPC_MINOR_VERSION .4)
 # -something for dev releases
 set(NTIRPC_VERSION_EXTRA )
 set(VERSION_COMMENT
@@ -115,6 +115,11 @@
   set(USE_LTTNG_NTIRPC OFF)
 endif(USE_LTTNG)
 
+find_library(LIBURCU_LIB urcu-bp)
+find_path(LIBURCU_INC urcu-bp.h)
+include_directories(${LIBURCU_INC})
+set(SYSTEM_LIBRARIES ${SYSTEM_LIBRARIES} ${LIBURCU_LIB})
+
 # Choose a shortcut build config
 
 IF(BUILD_CONFIG)
@@ -186,8 +191,6 @@
   "${EXTRA_INCLUDE_DIR}"
 )
 
-find_library(LIBURCU urcu-bp)
-
 # Find misc system libs
 find_library(LIBRT rt)   # extended Pthreads functions
 
@@ -196,7 +199,6 @@
   ${KRB5_LIBRARIES}
   ${SYSTEM_LIBRARIES}
   ${LIBRT}
-  ${LIBURCU}
 )
 
 if (NOT FREEBSD)

=== tests/CMakeLists.txt ===

SET(rpcping_SRCS
  rpcping.c
  )
add_executable(rpcping ${rpcping_SRCS})
target_link_libraries(rpcping ntirpc
  ${BINARY_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
  ${LTTNG_LIBRARIES}
  -ldl)

=== debian/changelog ===
ntirpc (3.4-2) unstable; urgency=medium

  * add depends libtirpc-common

 -- Christoph Martin <martin@uni-mainz.de>  Wed, 20 Jan 2021 14:38:20 +0100

ntirpc (3.4-1) unstable; urgency=medium

  * New upstream version 3.4

 -- Christoph Martin <martin@uni-mainz.de>  Tue, 19 Jan 2021 09:37:19 +0100

=== debian/control ===
--- 
+++ 
@@ -12,12 +12,12 @@
 Vcs-Git: https://salsa.debian.org/debian/libntirpc.git
 Vcs-Browser: https://salsa.debian.org/debian/libntirpc
 
-Package: libntirpc3.3
+Package: libntirpc3.4
 Section: libs
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}, libtirpc-common
 Description: new transport-independent RPC library
  Port of Sun's transport-independent RPC library to Linux. The library
  is intended as a replacement for the RPC code in the GNU C library,
@@ -36,7 +36,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libntirpc3.3 (= ${binary:Version}),
+Depends: ${misc:Depends}, libntirpc3.4 (= ${binary:Version}),
 Description: new transport-independent RPC library - development files
  Port of Sun's transport-independent RPC library to Linux. The library
  is intended as a replacement for the RPC code in the GNU C library,

=== debian/watch ===
version=3

 https://github.com/nfs-ganesha/ntirpc/releases \
  .*/archive/[Vv]?(\d[\d\.]+)\.tar\.(?:gz|bz2|xz)

 https://github.com/nfs-ganesha/ntirpc/releases?after=v1.7.1 \
  .*/archive/[Vv]?(\d[\d\.]+)\.tar\.(?:gz|bz2|xz)

## ntirpc 3.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 # version numbers
 set(NTIRPC_MAJOR_VERSION 3)
 # This is .0 for a release, .N for a stable branch, blank for development
-set(NTIRPC_MINOR_VERSION .4)
+set(NTIRPC_MINOR_VERSION .5)
 # -something for dev releases
 set(NTIRPC_VERSION_EXTRA )
 set(VERSION_COMMENT

=== debian/changelog ===
ntirpc (3.5-2) unstable; urgency=medium

  * include Debian Janitor fixes

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 10 Jan 2022 10:54:54 +0100

ntirpc (3.5-1) unstable; urgency=medium

  * update watchfile
  * New upstream version 3.5
  * bump debhelper-compat to 12
  * bump standards version (no changes)
  * cleanup copyright

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 03 Jan 2022 19:19:43 +0100

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,16 @@
 Priority: optional
 Maintainer: Dmitry Smirnov <onlyjob@debian.org>
 Uploaders: Christoph Martin <martin@uni-mainz.de>
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper-compat (= 13),
   cmake,
   libkrb5-dev,
   liburcu-dev,
-Standards-Version: 4.3.0
+Standards-Version: 4.5.1
 Homepage: https://github.com/nfs-ganesha/ntirpc
 Vcs-Git: https://salsa.debian.org/debian/libntirpc.git
 Vcs-Browser: https://salsa.debian.org/debian/libntirpc
 
-Package: libntirpc3.4
+Package: libntirpc3.5
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -36,7 +36,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libntirpc3.4 (= ${binary:Version}),
+Depends: ${misc:Depends}, libntirpc3.5 (= ${binary:Version}),
 Description: new transport-independent RPC library - development files
  Port of Sun's transport-independent RPC library to Linux. The library
  is intended as a replacement for the RPC code in the GNU C library,

## ntirpc 4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,9 +13,9 @@
 project(NTIRPC C)
 
 # version numbers
-set(NTIRPC_MAJOR_VERSION 3)
+set(NTIRPC_MAJOR_VERSION 4)
 # This is .0 for a release, .N for a stable branch, blank for development
-set(NTIRPC_MINOR_VERSION .5)
+set(NTIRPC_MINOR_VERSION .0)
 # -something for dev releases
 set(NTIRPC_VERSION_EXTRA )
 set(VERSION_COMMENT
@@ -140,9 +140,9 @@
   set(LINUX ON)
 endif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
 
-if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
-  set(FREEBSD ON)
-endif(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
+if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD|Darwin")
+  set(BSDBASED ON)
+endif(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD|Darwin")
 
 if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
   set(WINDOWS ON)
@@ -172,12 +172,12 @@
   set(SYSTEM_LIBRARIES ${WBclient_LIBRARIES} ${SYSTEM_LIBRARIES})
 endif(_MSPAC_SUPPORT)
 
-if (FREEBSD)
+if (BSDBASED)
    set(EXTRA_INCLUDE_DIR "/opt/ganesha/include")
 else()
   # workaround bug in some include_directories when no extra includes
   set(EXTRA_INCLUDE_DIR "${NTIRPC_BASE_DIR}/ntirpc/")
-endif(FREEBSD)
+endif(BSDBASED)
 
 add_definitions(-DHAVE_CONFIG_H)
 
@@ -191,23 +191,19 @@
   "${EXTRA_INCLUDE_DIR}"
 )
 
-# Find misc system libs
-find_library(LIBRT rt)   # extended Pthreads functions
-
 set(SYSTEM_LIBRARIES
   ${LIBTIRPC_LIBRARIES}
   ${KRB5_LIBRARIES}
   ${SYSTEM_LIBRARIES}
-  ${LIBRT}
-)
-
-if (NOT FREEBSD)
+)
+
+if (NOT BSDBASED)
   find_package(NSL) # sockets
   set(SYSTEM_LIBRARIES
     ${SYSTEM_LIBRARIES}
     ${NSL_LIBRARY}
   )
-endif (NOT FREEBSD)
+endif (NOT BSDBASED)
 
 set(LIBNTIRPC_MAP "${PROJECT_BINARY_DIR}/src/libntirpc.map")
 # subst files (need add_custom_command for dependency, fyi)

=== debian/changelog ===
ntirpc (4.0-2~bpo11+1) bullseye-backports; urgency=medium

  * backports rebuild

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 12 Sep 2022 12:02:10 +0200

ntirpc (4.0-2) unstable; urgency=medium

  * source only upload

 -- Christoph Martin <martin@uni-mainz.de>  Thu, 08 Sep 2022 09:50:26 +0200

ntirpc (4.0-1) unstable; urgency=medium

  * New upstream version 4.0

 -- Christoph Martin <martin@uni-mainz.de>  Wed, 07 Sep 2022 16:23:34 +0200

ntirpc (3.5-2~bpo11+1) bullseye-backports; urgency=medium

  * backports rebuild

 -- Christoph Martin <martin@uni-mainz.de>  Tue, 01 Feb 2022 11:09:21 +0100

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
 Vcs-Git: https://salsa.debian.org/debian/libntirpc.git
 Vcs-Browser: https://salsa.debian.org/debian/libntirpc
 
-Package: libntirpc3.5
+Package: libntirpc4.0
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -36,7 +36,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libntirpc3.5 (= ${binary:Version}),
+Depends: ${misc:Depends}, libntirpc4.0 (= ${binary:Version}),
 Description: new transport-independent RPC library - development files
  Port of Sun's transport-independent RPC library to Linux. The library
  is intended as a replacement for the RPC code in the GNU C library,

## ntirpc 4.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 # version numbers
 set(NTIRPC_MAJOR_VERSION 4)
 # This is .0 for a release, .N for a stable branch, blank for development
-set(NTIRPC_MINOR_VERSION .0)
+set(NTIRPC_MINOR_VERSION .3)
 # -something for dev releases
 set(NTIRPC_VERSION_EXTRA )
 set(VERSION_COMMENT

=== debian/changelog ===
ntirpc (4.3-2) unstable; urgency=medium

  * source only upload

 -- Christoph Martin <martin@uni-mainz.de>  Sun, 29 Jan 2023 09:15:08 +0100

ntirpc (4.3-1) unstable; urgency=medium

  * New upstream version 4.3

 -- Christoph Martin <martin@uni-mainz.de>  Tue, 24 Jan 2023 21:56:51 +0100

ntirpc (4.1-1) unstable; urgency=medium

  * New upstream version 4.1

 -- Christoph Martin <martin@uni-mainz.de>  Thu, 01 Dec 2022 11:26:09 +0100

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
 Vcs-Git: https://salsa.debian.org/debian/libntirpc.git
 Vcs-Browser: https://salsa.debian.org/debian/libntirpc
 
-Package: libntirpc4.0
+Package: libntirpc4.3
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -36,7 +36,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libntirpc4.0 (= ${binary:Version}),
+Depends: ${misc:Depends}, libntirpc4.3 (= ${binary:Version}),
 Description: new transport-independent RPC library - development files
  Port of Sun's transport-independent RPC library to Linux. The library
  is intended as a replacement for the RPC code in the GNU C library,

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,7 @@
 #PKG  = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))
 
 %:
-	dh $@ --parallel --buildsystem=cmake
+	dh $@ --buildsystem=cmake
 
 
 override_dh_auto_configure:
@@ -22,12 +22,12 @@
 	    -DTIRPC_EPOLL=1 \
 	    -DUSE_GSS=ON
 
-override_dh_auto_test:
-	set -ex; \
-	cd obj-$(DEB_BUILD_GNU_TYPE); \
-	for i in raw rdma tcp udp; do \
-		./tests/rpcping $$i localhost --count=1000 --threads=4 --workers=2; \
-	done
+#override_dh_auto_test:
+#	set -ex; \
+#	cd obj-$(DEB_BUILD_GNU_TYPE); \
+#	for i in raw rdma tcp udp; do \
+#		./tests/rpcping $$i localhost --count=1000 --threads=4 --workers=2; \
+#	done
 
 #override_dh_auto_install:
 #	dh_auto_install --destdir=$(CURDIR)/debian/tmp
